#ifndef __images_part_h__
#define __images_part_h__

#include <kparts/browserextension.h>
#include <klibloader.h>
#include <kaction.h>
#include "imagesview.h"

class KAboutData;
class KInstance;
class ImagesBrowserExtension;
class QLabel;

class ImagesFactory : public KLibFactory
{
    Q_OBJECT
public:
    ImagesFactory();
    virtual ~ImagesFactory();

  /*  virtual QObject* create(QObject* parent = 0, const char* name = 0,
                            const char* classname = "QObject",
                            const QStringList &args = QStringList()); */

    static KInstance *instance();
    static KAboutData *aboutData();

protected:
 QObject* createObject( QObject* parent = 0, const char* name = 0,
                                   const char* className = "QObject",
                                   const QStringList &args = QStringList() );

private:
    static KInstance *s_instance;
};

class ImagesPart: public KParts::ReadOnlyPart
{
    Q_OBJECT
public:
    ImagesPart(QWidget *parent, const char *name);
    virtual ~ImagesPart();

protected:
    virtual bool openFile();
    virtual bool closeURL();

protected slots:
      void proctoBlacknWhite();

private:
    imagesView *widget;
    ImagesBrowserExtension *m_extension;
    KAction * actiontoBlacknWhite;
};

class ImagesBrowserExtension : public KParts::BrowserExtension
{
    Q_OBJECT
    friend class ImagesPart;
public:
    ImagesBrowserExtension(ImagesPart *parent);
    virtual ~ImagesBrowserExtension();
};

#endif
